<!-- -------------------- ./adm/api_dsfr.html -------------------- -->

<!DOCTYPE html>
<html lang="fr">

<head>
  <!-- Required meta tags -->
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
  <meta name="ROBOTS" content="NOINDEX, NOFOLLOW" />
  <link rel="icon" type="image/ico" href="<?php echo $this->FAVICO; ?>" />

  <link rel="stylesheet" href="/pub/css/mgmt.css" />
  <link rel="stylesheet" href="/pub/dsfr/dsfr.min.css" />
  <link rel="stylesheet" href="/pub/dsfr/utility/icons/icons.css" />
  <link rel="stylesheet" href="/pub/css/open-signature.css" />

  <title><?php echo $this->APPNAM; ?></title>

  <script type="module" src="/pub/dsfr/dsfr.module.min.js" defer></script>
  <script type="text/javascript" nomodule src="/pub/dsfr/dsfr.nomodule.min.js" defer></script>
  <script src="/pub/jsint/open-signature.js"></script>
  <script src="/pub/jsext/jquery-3.3.1.min.js"></script>
  <script src="/pub/jsext/popper.min.js"></script>
</head>

<body class="os-wrapper">
  <header role="banner" class="fr-header os-header">
    <div class="fr-header__body">
      <div class="fr-header__body-row">
        <div class="fr-header__brand">
          <div class="fr-header__brand-top">
            <a href="/index.html">
              <div class="fr-header__logo os-logo">
                <img src="/pub/img/logosig2--dark.png" alt="Logo Signature" />
              </div>
            </a>
            <div class="fr-header__navbar">
              <button class="fr-btn--menu fr-btn" data-fr-opened="false" aria-controls="modal-main-menu" aria-haspopup="menu" title="Menu" id="fr-btn-menu-mobile">
                Menu
              </button>
            </div>
          </div>
          <div class="fr-header__service">
            <h1 class="fr-header__service-title"><?php echo $this->APPNAM; ?></h1>
            <p class="fr-header__service-tagline">
              <strong>API Documentation</strong><br>Plateforme de Signature Gironde Numerique
            </p>
          </div>
        </div>
      </div>
    </div>
    <!-- Navigation principale, même si vide, le laisser pour éviter une erreur JS du DSFR -->
    <div class="fr-header__menu fr-modal" id="modal-main-menu" aria-labelledby="fr-btn-menu-mobile">
      <div class="fr-container">
        <button class="fr-btn--close fr-btn" aria-controls="modal-main-menu" title="Fermer">
          Fermer
        </button>
        <div class="fr-header__menu-links"></div>
        <nav class="fr-nav" id="navigation-main-menu" role="navigation" aria-label="Menu principal">
          <ul class="fr-nav__list"></ul>
        </nav>
      </div>
    </div>
  </header>

<main class="os-main-content">
  <section class="fr-container--fluid">

<pre>  
  
<b>Test API</b>
  GET <?php printf("%s/Ping\n", $this->APIBAZ); ?>
   <em>no parameters</em>   
   <em>result :</em>   
     should respons "pong"
  
<b>Create a briefcase</b>
  GET <?php printf("%s/Create[/_title_]\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     _title_ = the briefcase title  - not mandatory ,  create API_AAAAMMDD_HHMMSS if not given
   <em>result :</em>   
     a json briefcase info :
      {
       "did":"UwjCiVIlO3DRKNHu1fvtbQzynsgcMa2o",                 <- the briefcase ID  
       "title":"the_title",                                      <- the given or generated title
       "passwd":"",                                              <- the ( empty at create ) password
       "endoflife":"aaaa-mm-dd"                                  <- the briefcase end of life 
      }

<b>Create a briefcase vith external application ID</b>
  GET <?php printf("%s/CreateWithExternID/nnn/xyzxyzxyzxyz[/_title_]\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     nnn = the external application number  ( 1=pastellGN, 2=parapheurGN, .... )
     xyzxyzxyzxyz = the ID given by the external application
     _title_ = the briefcase title  - not mandatory ,  create API_AAAAMMDD_HHMMSS if not given
   <em>result :</em>   
     a json briefcase info :
      {
       "did":"UwjCiVIlO3DRKNHu1fvtbQzynsgcMa2o",                 <- the real podoc briefcase ID  
       "title":"the_title",                                      <- the given or generated title
       "passwd":"",                                              <- the ( empty at create ) password
       "endoflife":"aaaa-mm-dd"                                  <- the briefcase end of life 
      }

<b>Get briefcase info</b>
  GET <?php printf("%s/Info/xxxxxxxxxxxxxxxxxxxxxxxxxxx\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     xxxxxxxxxxxxxxxxxxxxxxxxxxx = the briefcase ID - mandatory (32 chars)
   <em>result :</em>   
     the json briefcase info :
      {
       "did":"7R90t8j5eAIqUzLHOFBfXYn4ysMQDxS3",                 <- the briefcase ID  
       "title":"The Title",                                      <- the briefcase title
       "modified":"2021-09-24",                                  <- date of last modif
       "endoflife":"2021-10-09",                                 <- the briefcase end of life
       "filelist":["file001.jpg","file002.png"],                 <- list of briefcase files
       "advdat_creat":1632471479,                                <- creation date ( in epoch )
       "advdat_mod":1632471479,                                  <- modification date ( in epoch )
       "advdat_sigsts":null,                                     <- signature date ( in epoch )
       "advdat_blog":1632471479,                                 <- comment/blog date ( in epoch )
       "status":"standard_mode"                                  <- briefcase display mode
      }
   
 
<b>Add File(s)</b>
  POST <?php printf("%s/AddFile/xxxxxxxxxxxxxxxxxxxxxxxxxxx\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     xxxxxxxxxxxxxxxxxxxxxxxxxxx = the briefcase ID - mandatory (32 chars)
   <em>postdata :</em>
     nf1  = @/path/to/file         - at least 1 mandatory  
     nf2  = @/path/to/file    
     ....
     nf8  = @/path/to/file    
   <em>resultat :</em>   
     json upload status :
      {
       "status":"OK",
       "files uploaded":2
      }

<b>Delete File</b>
  GET <?php printf("%s/DelFile/xxxxxxxxxxxxxxxxxxxxxxxxxxx/_file_name_\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     xxxxxxxxxxxxxxxxxxxxxxxxxxx = the briefcase ID - mandatory (32 chars)
     _file_name_ = file name to delete  - mandatory 
   <em>resultat :</em>   
     json delete status :
      {
       "status":"OK",
       "files deleted":1
      }

<b>Delete Briefcase</b>
  GET <?php printf("%s/Del/xxxxxxxxxxxxxxxxxxxxxxxxxxx\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     xxxxxxxxxxxxxxxxxxxxxxxxxxx = the briefcase ID - mandatory (32 chars)
   <em>resultat :</em>   
     json delete status :
      {
       "status":"OK",
       "briefcase deleted":1
      }

   
<b>Fetch All Briefcase files</b>
  GET <?php printf("%s/FetchAll/xxxxxxxxxxxxxxxxxxxxxxxxxxx\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     xxxxxxxxxxxxxxxxxxxxxxxxxxx = the briefcase ID - mandatory (32 chars)
   <em>resultat :</em>   
     a zip of all the briefcase files

   
<b>Fetch a file</b>
  GET <?php printf("%s/FetchFile/xxxxxxxxxxxxxxxxxxxxxxxxxxx/_file_name_\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     xxxxxxxxxxxxxxxxxxxxxxxxxxx = the briefcase ID - mandatory (32 chars)
     _file_name_ = file name to fetch - mandatory 
   <em>resultat :</em>   
     the file content

   
<b>Ask for Signature</b>
  GET <?php printf("%s/Ask4Sign/xxxxxxxxxxxxxxxxxxxxxxxxxxx/_signator_mail_/_asker_mail_\n", $this->APIBAZ); ?>
   <em>parameters :</em>
     xxxxxxxxxxxxxxxxxxxxxxxxxxx = the briefcase ID - mandatory (32 chars)
     _signator_mail_ = the mail of the person who have to sign the briefcase -  mandatory 
     _asker_mail_ = the mail of the person who request the signature  -  not mandatory 
   <em>resultat :</em>   
     json signature request  status :
      {
       "status":"OK",
       "message":"signature asked"
      }

</pre>
   

<a href="/">Retour</a>

  </section>
  </main>
  
</body></html>


